#!/bin/bash

OUTPUT_DIR="/srv/www/nconf/output/"
NAGIOS_DIR="/etc/nagios/"
TEMP_DIR=${NAGIOS_DIR}"import/"
CONF_ARCHIVE="NagiosConfig.tgz"

function update_config() {
    cp -p "${OUTPUT_DIR}${CONF_ARCHIVE}" "${TEMP_DIR}${CONF_ARCHIVE}"
    tar -xf "${TEMP_DIR}${CONF_ARCHIVE}" -C "${NAGIOS_DIR}"
    for file in $(tar -tf "${TEMP_DIR}${CONF_ARCHIVE}"); do
        chown root:root "${NAGIOS_DIR}$file"
    done 
    /etc/init.d/nagios reload
}

if [ ! -e "${TEMP_DIR}" ] ; then
    mkdir -p "${TEMP_DIR}"
fi

if [ ! -e "${TEMP_DIR}${CONF_ARCHIVE}" ]; then
	update_config
fi

if [ "${OUTPUT_DIR}${CONF_ARCHIVE}" -nt "${TEMP_DIR}${CONF_ARCHIVE}" ] ; then
    update_config
fi

exit
